<template>
  <div
    v-show="checkIsFavourite(gameData.GameId)"
    :class="[
      'favourite-no-animation-heart',
      `colorFade-heart-${gameData.GameId}`,
      {
        '!w-5 !h-5': isMobile,
      },
    ]"
  >
    <SvgIcon
      id="active-favourite"
      :class-name="[
        `scale-animation-heart-${gameData.GameId}`,
        'h-6 w-6 active-heart',
      ]"
      :class="{
        '!w-5 !h-5': isMobile,
      }"
      svg-name="icon-heart"
      @click.stop="
        authenticated
          ? setAndUnsetGameToFavourite(gameData, false, index)
          : checkRedirectToLoginOrToggleDialog()
      "
    />
  </div>
  <SvgIcon
    v-show="!checkIsFavourite(gameData.GameId)"
    id="inactive-favourite w-6 h-6"
    :class="{
      '!w-5 !h-5': isMobile,
    }"
    :class-name="['favourite-animation-heart', { 'opacity-0': !ForMobile }]"
    svg-name="icon-heart"
    @click.stop="
      authenticated
        ? setAndUnsetGameToFavourite(gameData, true, index)
        : checkRedirectToLoginOrToggleDialog()
    "
  />
</template>

<script lang="ts" setup>
import { PropType } from "vue";
import { GameBsi } from "@/models/bsiGameList";
import { store } from "~~/store";

const authenticated = computed(() => store.state.auth);

const props = defineProps({
  gameData: {
    type: Object as PropType<GameBsi>,
  },
  checkIsFavourite: {
    type: Function,
    required: true,
  },
  setAndUnsetGameToFavourite: {
    type: Function,
    required: true,
  },
  redirectToLogin: {
    type: Function,
    required: true,
  },
  ForMobile: {
    type: Boolean,
    default: false,
  },
  toggleDialog: {
    type: Boolean,
    default: false,
  },
});
const { toggleLoginRegisterDialog } = commonHelper;
const checkRedirectToLoginOrToggleDialog = () => {
  return props.toggleDialog
    ? toggleLoginRegisterDialog()
    : props.redirectToLogin();
};
const isMobile = !useIsDesktop();
</script>

<style lang="postcss">
.favourite-no-animation-heart {
  @apply absolute top-[5px] right-[5px] h-6 w-6 z-20 rounded-md items-center justify-center flex;
}
.favourite-animation-heart {
  @apply absolute top-[5px] right-[5px] h-6 w-6 z-20 rounded-lg;
  fill: none;
  stroke: white;
}
@keyframes fadeInFromBottom {
  0% {
    opacity: 0;
    transform: translateY(100%);
  }
  100% {
    opacity: 1;
    transform: translateY(0);
  }
}
@keyframes fadeInFromTop {
  0% {
    opacity: 0;
    transform: translateY(-100%);
  }
  100% {
    opacity: 1;
    transform: translateY(0);
  }
}
@keyframes fadeOutToTop {
  0% {
    opacity: 0;
    transform: translateY(-100%);
  }
  100% {
    opacity: 1;
    transform: translateY(0);
  }
}
@keyframes scaleAnimation-heart {
  0% {
    transform: scale(1);
  }
  33% {
    transform: scale(0.8);
  }
  66% {
    transform: scale(1.2);
  }
  100% {
    transform: scale(1);
  }
}
@keyframes fadeColor-heart {
  0% {
    fill: transparent;
    stroke: white;
  }
  33% {
    fill: rgba(242, 116, 139, 1);
    stroke: transparent;
  }
  100% {
    fill: rgba(242, 116, 139, 1);
  }
}
@keyframes heart-fade-out {
  0% {
    fill: rgba(242, 116, 139, 1);
  }
  100% {
    fill: transparent;
  }
}
.group:hover .play__now__content_for_animate {
  animation: fadeInFromBottom 0.5s ease-in-out;
}
.group:hover .favourite-animation {
  @apply opacity-100;
  animation: fadeInFromTop 0.5s ease-in-out forwards;
}
.scale-animation-heart {
  animation-iteration-count: 1;
  animation: scaleAnimation-heart 1.5s forwards ease-out,
    fadeColor-heart 1.5s forwards ease-out;
}
.favourite-no-animation-heart:has(.favorite-inactive-delay) {
  z-index: 30;
  display: unset !important;
}
.active-heart {
  fill: rgba(242, 116, 139, 1);
}
.active-heart.favorite-inactive-delay {
  animation: heart-fade-out 0.5s forwards ease-out;
}
</style>
